###############
sub my_action {
###############
    # jan 2024, win

#override with private functions?
##################################
eval { &mylib_menue_folder_create };                   # create this function in a private mylib.pl to replace this action
my ($var1,$ant,$utf,$z,$r,$f,$k,$ks,$mess,$t1,$t1,@m);

&load_lib("keyserverlib.pl");  # common subs


# get default enc values
$ks=",on:passphrase_prompt";                 # default, always

# add enc save key (file|web)
# for file/web check if defaults are set, ex value_keydata_fs        ->         'tank/usb/keydata'
# filebased split settings: all, local, web, none

if ($cfg{'value_keydata_fs'}=~/\/\w/)  {

   # add L1
   $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
   if   (($r eq "1") && ($cfg{'select_key_split'} =~/local|all/)) {             # first local folder

         # L1:L1
         if ($sys{'auto_os'} eq "Linux") {
                  $ks.=",on:passphrase_tmpfile_L1:L1";                          #   file option
         } else {
                  $ks.=",on:passphrase_save_L1:L1";                             #   file  + prompt option
         }

         # add :L2?
         if (($cfg{'value_keydata_fs2'}=~/\/\w/) && ($cfg{'ver'}=~/\w/)) {
            $r=`sudo test -d "/$cfg{'value_keydata_fs2'}" && echo 1 || echo 2`;  chomp($r);
            if (($r eq "1") && ($cfg{'select_key_split'} =~/local|all/))  {     # second local folder

               # L1:L2
               if ($sys{'auto_os'} eq "Linux") {
                    $ks.=",on:passphrase_tmpfile_L1:L2";      # only option here is L1:L2
               } else {
                    $ks.=",on:passphrase_save_L1:L2";         # only option here is L1:L2   (file->prompt)
               }
            }
         }
   }
}

# save web2 ex W1:Wx
# $p{'key_par'}='fsid=&hostid=&action=&keypart=&hostname=&data='; from top of keyserverlib
#&print_hash(%cfg);

if (($cfg{'select_key_split'} =~/web|all/) && ($cfg{'value_key_hostid'}=~/\w/))  {   # local either W1:W1 or W1:W2
            $mess="";
            $t=$p{'key_par'};
            $t=~s/hostid=/hostid=$cfg{'value_key_hostid'}/;
            $t=~s/action=/action=check/;
#&mess($t);
            # W1:W1
            if (!($cfg{'ver'}=~/\w/)) {  $cfg{'value_key_server2'}="";  }
            if ( ($cfg{'value_key_server1'}=~/:\/\/\w/) && (!($cfg{'value_key_server2'}=~/:\/\/\w/)) ) {

               #
               $t1=`wget -O - --no-check-certificate --post-data "$t" $cfg{'value_key_server1'}/cgi-bin/keyserver.pl 2>/dev/null`;
#&mess($t1);
               if ($t1=~/keyserver:ok/)  {
                 if ($sys{'auto_os'} eq "Linux") {
                    $ks.=",on:passphrase_tmpfile_W1:W1";       # only option here is W1:W2     /tmp/file
                 } else {
                    $ks.=",on:passphrase_save_W1:W1";          # only option here is W1:W2     file-> prompt
                 }
               }
            }

            # W1:W2
            if ( ($cfg{'value_key_server1'}=~/:\/\//) && ($cfg{'value_key_server2'}=~/:\/\//) && ($cfg{'ver'}=~/\w/) ) {
               #
               $t1=`wget -O - --no-check-certificate --post-data "$t" $cfg{'value_key_server1'}/cgi-bin/keyserver.pl 2>/dev/null`;
               $t2=`wget -O - --no-check-certificate --post-data "$t" $cfg{'value_key_server2'}/cgi-bin/keyserver.pl 2>/dev/null`;
               if (($t1=~/keyserver:ok/) && ($t2=~/keyserver:ok/))  {
                 if ($sys{'auto_os'} eq "Linux") {
                    $ks.=",on:passphrase_tmpfile_W1:W2";       # only option here is W1:W2     /tmp/file
                 } else {
                    $ks.=",on:passphrase_save_W1:W2";          # only option here is W1:W2     file-> prompt
                 }
               } else { $mess="webserver-1 or webserver-2 not accessable";}
             }


         # save mixed ex L1:W1
         if (($cfg{'value_keydata_fs'}=~/\/\w/) && ($cfg{'ver'}=~/\w/))  {
             $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
             if (($r eq "1") && ($cfg{'value_key_server1'}=~/:\/\/\w/)) {

                 $t1=`wget -O - --no-check-certificate --post-data "$t" $cfg{'value_key_server1'}/cgi-bin/keyserver.pl 2>/dev/null`;
#&mess("wget -O - --no-check-certificate --post-data \"$t\" $p{'key_server1'}/cgi-bin/keyserver.pl 2>/dev/null<br>$t1");
                 $mess="";
                 if ($t1=~/keyserver:ok/is) {
                   if ($sys{'auto_os'} eq "Linux") {
                      $ks.=",on:passphrase_tmpfile_L1:W1";    # only option here is L1:W2
                    } else {
                      $ks.=",on:passphrase_save_L1:W1";       # only option here is L1:W2
                    }
                 }
              }
         }
}

#&print_hash(%in);
if ($in{'autoselect_crypt'}=~/save|file/) {         # ex save_L1:L2
        $f=&verify_keyfolder;        # check for keyfolder
        &get_key_defaults;           # > %p
        if (!($in{'autoselect_crypt'}=~/W|L/)) { &mess("Please set web or filebased split method for to save encrypred keys<br>in menu ZFS Filesystems > Encryption > Defaults"); }
}

# header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='$txt{'header'}'</script>\n";


# 1. edited=
  if ($in{'submit_ok'} ne "submit")     { $in{'answered'} =""; }  #not klicked on submit but on autoselect (encrypt)
  if ($in{'answered'}) { &my_create; }     # form -> create

# 1b. get subfolders below current pool
  $ant=&exe("zfs list -H -t filesystem -o name ");
  @t=();
  @t=split(/\n/,$ant);
  foreach $t (@t) {
     if ($t=~/^$zfs{'syspool'}/) { next; }
     $z.="$t,";
  }
  $z.="$zfs{'syspool'}";                          # allow creation of fs under rpool

  $z=~s/,$//;
  if ($z eq "") { $z=$zfs{'datapools'}; }

# 2. get form
#########################
if ($in{'autoselect_pool'} eq "") {   $in{'autoselect_pool'}=$zfs{'datapools'}; $in{'autoselect_pool'} =~s/\t.*//; }

print "<br><b style='font-size:16px'>Filesystem pool and name</b><br>";

&ask('begin');
&ask('autoselect_pool','Pool or parent filesystem',$z,$in{'autoselect_pool'});
&ask('value_new',$txt{'form_zfsname'},$in{'value_new'});

print "<br><br><b style='font-size:16px'>Encryption settings</b><br><br>";



## encrypt, now in Illumos
$t=&exe("zfs get all $in{'autoselect_pool'}");
chomp($t);
#ex: tank  encryption            off

if (!($t=~/encryption/s)) {
    &ask('select_crypt','ZFS Encryption (BSD, Illumos, Linux, OSX or Windows) ',"not available");

} else {

     #selected pool = first or selected
     if ($in{'autoselect_pool'} eq "") {
          $t=$zfs{'datapools'}; $t=~s/\t.*//;        # first pool
     } else {
          $t=$in{'autoselect_pool'};
     }

     $t.="_encryption";

     #pool encr=on
     if ($zfs{$t} eq "on") {
             print "<b>Encryption</b> was set to on for all folders of this pool<br><br><br>";
     }

     ### martingo 20180306 >>> Wenn autoselect_pool ein verschluesseltes ZFS ist, kann es den keystatus unavailable (nicht entschluesselt)
     ### oder available (verschluesselt) haben.
     ### Wenn es nicht verschluesselt ist, ist der keystatus none
     ### Wenn das Parent ZFS bereits verschluesselt ist, gibt es im DropDown nur noch die Moeglichkeit auto.

      if ( $zfs{ $in{'autoselect_pool'} . '_keystatus' } =~ /^(un)?available$/ ) {
             &ask('autoselect_crypt','Encryption inherited from parent','auto');

      } else {

            #  ask always
            #if (($in{'autoselect_crypt'} =~/prompt/) || ($in{'autoselect_crypt'} eq "") || ($in{'autoselect_crypt'} eq "off") )  {  # default
               &ask('autoselect_crypt',"ZFS filesystem encryption with keysource</b><br>With keysource=prompt, there is no file backup of your key.<br>Allow file/webbased keys in About &gt; Settings<br>$mess<b>","off$ks",$in{'autoselect_crypt'});
            #}


            if ($in{'autoselect_crypt'} =~/on/) {
                 &ask('select_str','Strenght',"aes-256-gcm,aes-256-ccm,aes-128-ccm,aes-192-ccm,aes-128-gcm,aes-192-gcm",$in{'select_str'});

                 if ($in{'autoselect_crypt'} =~/prompt/) {
                    print "<br><b class='font_darkred'> Without this passphrase, you will never be able to reaccess your data, backup passphrase at a safe place and DO NOT FORGET!<br>Try a lock + unlock prior use! </b><br><br>";
                 } else {
                    print "<br><b class='font_darkred'> Without this passphrase, you will never be able to reaccess your data, Backup passphrase or files fsid.kp1 and fsid.kp2<br> and keep them at a safe place! Verify selected destination now. Try a lock + unlock prior use! </b><br><br>";
                 }

                 #prompt
                 if ($in{'autoselect_crypt'} =~/prompt/) {
                      &ask('value_crypt1pass','Passphrase 8-512 char','','w420');
                      &ask('value_crypt2pass','Repeat Passphrase','','w420');
                      $t=&get_random_ascii(64);
                      &ask('value_x','Random 64 Byte Passphrase suggestion (copy/paste and backup)',$t,'w420readonly');
                 }


                 #file passphrase
                 if ($in{'autoselect_crypt'} =~/save|file/) {               # file=keylocation -> /tmp/fsid.key

                      $f=&verify_keyfolder;        # check for keyfolder
                      &get_key_defaults;           # > %p
     #&print_hash(%p);

                      #keydata_fs required
                      $r=`sudo test -d "/$p{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
                      if ($r eq "2") {
                        &mess("You cannot use file or http as keylocation:<hr>Keydata filesystem $p{'keydata_fs'} not found (About > Settings).");
                      }

                      $k=&get_random_ascii(64);
                      &ask('hidden','value_crypt1pass',$k);           # set key

                      # show key?
                      $t="<a href=\"#\" onclick=\"\$('.showkey').toggle();\">Show/hide full key (part1+part2)</a>";
                      print "<div class='showkey' style='display:block'>";
                      &ask('value_show2',"Passphrase key: Autogenerated 64 char</b><br>$t<b>",'**********','w420 readonly');
                      print "</div>";

                      print "<div class='showkey' style='display:none'>";
                        &ask('value_show2',"Passphrase key: Autogenerated 64 char</b><br>$t<b>",$k,'w420 readonly');
                      print "</div>";

                      &ask('value_split','Key split part1, part2 (L=local, W=webserver)<br></b>from About &gt; Settings<b',$cfg{'select_key_split'},readonly);

                      # info only
                      if ($in{'autoselect_crypt'} =~/L1/) {
                         &ask('value_11','Local keyfolder L1 (ex pool/keydata)',"$cfg{'value_keydata_fs'}",'readonly');
                      }
                      if ($in{'autoselect_crypt'} =~/L2/) {
                         &ask('value_12','Local keyfolder L2 (ex pool2/keydata)',"$cfg{'value_keydata_fs2'}",'readonly');
                      }
                      if ($in{'autoselect_crypt'} =~/W1/) {
                         &ask('value_w1','Keyserver W1',"$cfg{'value_key_server1'}",'readonly');
                      }
                      if ($in{'autoselect_crypt'} =~/W2/) {
                         &ask('value_w2','Keyserver W2',"$cfg{'value_key_server2'}",'readonly');
                      }

                      &ask('select_automount','Automount on bootup</b><br>(keyserver service must be enabled and keys available)<b>',"no,yes",$in{'select_automount'});


                 }
            }
      }
}

#debug
#&print_hash(%cfg);

print "<br><br>";
print "<b style='font-size:16px'>Other settings</b><br><br>";

print " <i>$txt{'form_atime_i'}</i><br>";
&ask('select_atime',"Atime (access time)",'off,on');
&ask('select_copies',"Copies=2 writes any datablock twice as an option for <br>single disk pools like USB sticks or disks to autorepair files with bad datablocks",'1,2');

#obsolet netatalk 3 ?
print " <i>$txt{'form_nbmand_i'}</i><br>";
&ask('select_nbmand','nbmand (filelocking, should be on)','on,off');


#recordsize
  print "read about recordsize: blogs from <a href='http://www.joyent.com/blog/bruning-questions-zfs-record-size' target='_blank'>Joyent</a> and <a href='https://blogs.oracle.com/roch/entry/tuning_zfs_recordsize' target='_blank'>Oracle</a>";
  &ask('select_recordsize',"ZFS recordsize (default=128k","default,1m,128k,64k,32k,16k,8k,4k",$in{'select_version'});

 #compress
  print "ZFS lz4 compress is very effective. You can enable it in most cases per default with any type of data";
  &ask('select_compress',"ZFS compress (lz4)","on,off",$in{'select_compress'});

# create only
print "settings that cannot be changed after creation<br><br>";

#utf8only
print " <i>utf8only and normalization</i><br>";
&ask('select_utf','set to off for cases like <br>rsync to NFS3 with special chars','on formD,off');

print "<i>$txt{'form_sens_info'}</i><br>";
&ask('select_sensitivity','case sensitivity','insensitive,sensitive,mixed');

&ask('end');

print "<br><br><div class='info'>\ncreate a new ZFS-folder/ dataset (with the following defaults):<br><br>keep in mind: SMB and AFP use ACL, some like ftp use unix permissions. <br>create-defaults are: root=full, everybody=modify, nbmand=off and utf8 charset to prevent illegal characters in filenames <br>";
print "default unix permissions are set to 777 = full access for everybody, needed for ACL settings and smb-guest access. Restrict them only if needed and use ACL for your shares</div><br><br>";



print "<br><br>ZFS:<br>";
$r=&exe("zfs list -t filesystem");
$r=~s/  +/\t/gs;

if ($cfg{'select_lang'}=~/my|app/i) {
   $r=~s/napp\-it/*appl*/gs;
}

print &list2table($r);
print "<br>";
#########################

# header
print "<script language='javascript'>document.getElementById('hl').innerHTML='create ZFS filesystem on $in{'member'}'</script>\n";


} #/ my_action
################

################         # create encrypted on Solaris
sub my_create_enc {
################
        my ($do,$key,$f,$fo,$id,$par,@id,$f1,$f2,$ft,$k1,$k2,$guest);


        #utf8 only and normalization=on or none (default)
         $utf=" -o utf8only=on -o normalization=formD";
         if ($in{'select_utf'} eq "off") { $utf=""; }

        # add recordsize
        if ($in{'select_recordsize'}=~/\d/) {
          $utf.=" -o recordsize=$in{'select_recordsize'}";
        }

        # add compress
        if ($in{'select_compress'}=~/on/) {
          $utf.=" -o compress=lz4";
        }

        # enc on Solaris:  -o keysource=passphrase,prompt
        # enc on Illumos:  -o keyformat=passphrase -o keylocation=prompt
        # enc on Linux:    -o keyformat=passphrase -o keylocation=file://abspath (Expect missing)

        $id="$in{'autoselect_pool'}/$in{'value_new'}";
        $id=~s/ /_/g; $id=~s/\//~/g;

        # when automount=yes: zfs set automount:=yes
           if ($sys{'auto_os'}=~/Solaris/i)  {
             $key=" -o keysource=passphrase,prompt";                            # keysource=passphrase,prompt
           }

           if ($sys{'auto_os_type'}=~/ill/i) {
             $key=" -o keyformat=passphrase -o keylocation=prompt";              # keyformat=passphrase -o keylocation=prompt
           }

           if ($sys{'auto_os'}=~/Linux/i)    {
             $key=" -o keysource=passphrase,file:///tmp/nappit/$id.key";         # Linux keysource=file otherwise prompt (via Expect)
             $ft="/tmp/nappit/$id.key";
           }

        $in{'value_new'}=~s/\/+$//;

        if ($in{'autoselect_crypt'}=~/save|file/) {                               # file=keylocation -> /tmp/fsid.key
           # fs keysource (sol) or keylocation (Ill) always prompt (Linux file)
           # parts of key are stored as set in split (L:W)

           # check keyfolders
           $f=&verify_keyfolder;           #folder ../keydata   or mess
           ($k1,$k2)=&get_keysplit($in{'value_crypt1pass'});


           #save temp keyfile
           if ($sys{'auto_os'}=~/Linux/i)    {
               $r=&save_key_local($ft,$in{'value_crypt1pass'},"700","root");      # keylib
           }

           $r="";
           if ($in{'autoselect_crypt'}=~/L1:/) {
               $f1="/$cfg{'value_keydata_fs'}/local/keys-part1/$id.kp1";                                # keypart 1
               #save kp1 on L1
               $r.=&save_key_local($f1,$k1,"700","root");                         # keylib
           }

           if ($in{'autoselect_crypt'}=~/:L1/) {
               $f2="/$cfg{'value_keydata_fs'}/local/keys-part2/$id.kp2";                                # keypart 2
               #save kp2 on L1
               $r.=&save_key_local($f2,$k2,"700","root");                         # keylib
           }

           if ($in{'autoselect_crypt'}=~/:L2/) {
               $f2="/$cfg{'value_keydata_fs2'}/local/keys-part2/$id.kp2";                 # keypart 2
               #save kp2 on L2
               $r.=&save_key_local($f2,$k2,"700","root");                         # keylib
           }
#&print_hash(%p);

           $r="";
           # first part of key
           if ($in{'autoselect_crypt'}=~/W1:/) {

               $par=$p{'key_par'};
#&mess($par);
               #hostid
               $par=~s/hostid=/hostid=$cfg{'value_key_hostid'}/;      ## ex: 'keyserver.pl?&fsid=&hostid=&action=&part=&hostname=&data='

               #fsid
               $par=~s/fsid=/fsid=$id/;

               #hostname
               $t=`hostname`;  chomp($t);
               $par=~s/hostname=/hostname=$t/;

               # action
               $par=~s/action=/action=write/;

               #data
               $par=~s/data=/data=$k1/;

               #part
               $par=~s/part=/part=1/;

               #save
               $r.="$cfg{'value_key_server1'} p1: ";
               $r.=&call_key_web($cfg{'value_key_server1'},"$par");            # keylib
               $r.="<br>";

           }

           #second part
           if ($in{'autoselect_crypt'}=~/:W1/) {
               $par=$p{'key_par'};

               #hostid
               $par=~s/hostid=/hostid=$cfg{'value_key_hostid'}/;      ## ex: 'keyserver.pl?&fsid=&hostid=&action=&part=&hostname=&data='

               #fsid
               $par=~s/fsid=/fsid=$id/;

               #hostname
               $t=`hostname`; chomp($t);
               $par=~s/hostname=/hostname=$t/;

               # action
               $par=~s/action=/action=write/;

               #data
               $par=~s/data=/data=$k2/;

               #part
               $par=~s/part=/part=2/;

               #save
               $r.="$cfg{'value_key_server1'} p2: ";
               $r.=&call_key_web($cfg{'value_key_server1'},"$par");            # keylib
               $r.="<br>";
           }

           if ($in{'autoselect_crypt'}=~/:W2/) {                       # L1:W2 or W1:W2
               $par=$p{'key_par'};

               #hostid
               $par=~s/hostid=/hostid=$cfg{'value_key_hostid'}/;      ## ex: 'keyserver.pl?&fsid=&hostid=&action=&part=&hostname=&data='

               #fsid
               $par=~s/fsid=/fsid=$id/;

               #hostname
               $t=`hostname`; chomp($t);
               $par=~s/hostname=/hostname=$t/;

               # action
               $par=~s/action=/action=write/;

               #data
               $par=~s/data=/data=$k2/;

               #part
               $par=~s/part=/part=2/;

               #save
               $r.="$cfg{'value_key_server2'} p2: ";
               $r.=&call_key_web($cfg{'value_key_server2'},"$par");            # keylib
           }
        }

#&mess($par);
#&print_hash(%p);
#&mess("$par<br>$r");

        if ($in{'autoselect_crypt'}=~/W/) {
              if ($r =~/error/s) { &mess($r); }
        }

        # create enc (prompt, Linux=file in /tmp)
        $do="/sbin/zfs create$utf -o encryption=$in{'select_str'}$key -o snapdir=hidden -o casesensitivity=$in{'select_sensitivity'} -o nbmand=$in{'select_nbmand'} -o sharesmb=off -o atime=$in{'select_atime'} $in{'autoselect_pool'}/$in{'value_new'}";
        #print "$do<br>";
#&print_hash(%in);

        if ($sys{'auto_os'}=~/Linux/i)    {  # remove expect
             sleep(1);
             return();
        }

       # use Expect;
        #my $exp;   #->raw_pty(1);
        #my $exp = Expect->new;
        #$exp->raw_pty(1);
        #$exp = Expect->spawn("sudo $do") or die "Couldn't create zfs: $!\n";
        #$exp->log_stdout(1);             # echo off

        # my $exp;   #->raw_pty(1);
              $exp = Expect->spawn("sudo $do") or die "Couldn't create zfs: $!\n";

              $exp->expect(3,
                   [ 'passphrase' =>
                            sub {
                                $exp->send("$in{'value_crypt1pass'}\r");
                                print "Enter passphrase: ******** <br>\n";
                                exp_continue;
                                #sleep(1);
                            }
                   ] ,
                   [ 'again' =>
                            sub {
                                $exp->send("$in{'value_crypt1pass'}\r");
                                print "Enter again: ****<br>\n";
                                exp_continue;
                                #sleep(1);
                            }
                   ]
               );
               $exp->soft_close();

               # add zfs property automount
               `sudo /sbin/zfs set enc_automount:=$in{'select_automount'} $in{'autoselect_pool'}/$in{'value_new'}`;


               #add enc_smbak:
               if (!(-d "/var/web-gui/_log/autolock")) {
                   mkdir ("/var/web-gui/_log/autolock");
                   &exe("chmod 700 /var/web-gui/_log/autolock");           #napp-it
               }
               if (!(-d "/var/web-gui/_log/autolock/settings")) {
                   mkdir ("/var/web-gui/_log/autolock/settings");
                   &exe("chmod 700 /var/web-gui/_log/autolock/settings");  #napp-it
               }


               #$r=&key_get_smbak($in{'value_crypt1pass'});
               #`sudo /sbin/zfs set enc_smbak:=$r $in{'autoselect_pool'}/$in{'value_new'}`;     # this is used to lock/unlock via smb
               # request in realtim from ZFS > Encryption, do not write as a property

               # add share info
               $guest="";
               if ($in{'select_guest'} eq 'on') { $guest=',guestok=true'; }

               $t="sharesmb=name=\"$in{'value_new'}$guest\"";
               `sudo /sbin/zfs set enc_smbshare:=$t $in{'autoselect_pool'}/$in{'value_new'}`;

               # split info
               $t=$in{'autoselect_crypt'};  # on:passphrase_save_L1:W1
               $t=~s/.*\_//;                # L1:W1

               `sudo /sbin/zfs set enc_split:=$t $in{'autoselect_pool'}/$in{'value_new'}`;
#exit;
               sleep(1);
               return();
}


################
sub my_create {
################
  my ($do,$guest,$version,$utf,$exp,$f,$key,$file,$r,$t1,$t2);

#&print_hash(%in);
  # zfs create -o casesensitivity=insensitive -o nbmand=on fsname

   #strict
   $in{'value_new'}=~s/[^a-zA-Z0-9_\/\.\-:]//g;            # allowed in name
   $in{'value_new'}=~s/^\/+//g;                            # not allowed in name

   if ($in{'value_new'} eq '') { &mess('name of dataset?'); }

   my $zfs="$in{'autoselect_pool'}/$in{'value_new'}";

   #exist??
   $t=&exe("zfs list -H -o name $zfs");
   chomp($t);
   if ($t eq "$zfs")  { &mess("filesystem $zfs already exists!"); }

   #crypt
   if ($in{'autoselect_crypt'} =~/prompt/) {
     &mess('under development');
     if ($in{'value_crypt1pass'} eq "") {                         &mess('You must enter a passphrase to enable encrypt!'); }
     if (length($in{'value_crypt1pass'}) < 8) {                   &mess('Your passphrase must have at least 8 char'); }
     if (length($in{'value_crypt1pass'}) >512) {                  &mess('Your passphrase must not have more than 512 char'); }
     if ($in{'value_crypt1pass'} ne $in{'value_crypt2pass'}) {    &mess('your Passphrases are different'); }
   }


   # verify default settings (L1 always available)
   if ($in{'autoselect_crypt'} =~/save|file/) {                # file=keylocation -> /tmp/fsid.key
        # save   L1,L2,W1,W2
        if ($in{'autoselect_crypt'}=~/L2/) {
             if (!($cfg{'value_keydata_fs2'}=~/\/\w+/))                {    &mess('Keydata 2 filesystem not defined but required for split local-1/2'); }
             if ($cfg{'value_keydata_fs2'}=~/^\//)                     {    &mess('Keydata 2 filesystem path must be absolute like pool/data'); }

             $r=`sudo test -d "/$cfg{'value_keydata_fs2'}" && echo 1 || echo 2`;  chomp($r);
             if ($r eq "2")                                    {    &mess("Keydata 2 filesystem $cfg{'value_keydata_fs2'} not found"); }
        }
        if ($in{'autoselect_crypt'}=~/W1/) {
             # avail?

             $t=$p{'key_par'}; $t=~s/hostid=/hostid=$cfg{'value_key_hostid'}\&action=check/;

#&print_hash(%cfg);
             $t1=`wget -O - --no-check-certificate --post-data "$t" $cfg{'value_key_server1'}/cgi-bin/keyserver.pl 2>/dev/null`;
#&mess("$t<hr>$t1");

             if ($t1 =~/error/)                                { &mess($t1); }
        }
        if ($in{'autoselect_crypt'}=~/W2/) {
             $t=$p{'key_par'}; $t=~s/hostid=/hostid=$cfg{'value_key_hostid'}\&action=check/;
             $t1=`wget -O - --no-check-certificate --post-data "$t" $cfg{'value_key_server2'}/cgi-bin/keyserver.pl 2>/dev/null`;
#&mess("$t<hr>$t1");
             if ($t1 =~/error/)                                { &mess($t1); }
        }
   }

  #&print_hash(%in);


   #################################
   #create fs
   ############
   #parse perm


   # with encryption
   if ($in{'autoselect_crypt'}=~/on/) {

         &my_create_enc;

   } else {                     #without encryption or auto (inherit)
         #
         #utf8 only and normalization=on or none (default)
         $utf=" -o utf8only=on -o normalization=formD";
         if ($in{'select_utf'} eq "off") { $utf=""; }

         #  add recordsize
         if ($in{'select_recordsize'}=~/\d/) {
            $utf.=" -o recordsize=$in{'select_recordsize'}";
         }

         # add copies
         if ($in{'select_copies'} eq "2") {
             $utf.=" -o copies=2";
         }

         # add compress
         if ($in{'select_compress'}=~/on/) {
             $utf.=" -o compress=lz4";
         }


         #snapdir hidden, access via windows previous version
         # option compress=inherit or off

         $in{'value_new'}=~s/ /_/g;    # no spaces

         # $do="zfs create$version$utf -o snapdir=hidden -o casesensitivity=$in{'select_sensitivity'} -o nbmand=$in{'select_nbmand'} -o sharesmb=off -o atime=$in{'select_atime'} -o compression=off \"$in{'autoselect_pool'}/$in{'value_new'}\"";
         $do="zfs create$utf -o snapdir=hidden -o casesensitivity=$in{'select_sensitivity'} -o nbmand=$in{'select_nbmand'} -o sharesmb=off -o atime=$in{'select_atime'} $in{'autoselect_pool'}/$in{'value_new'}";
    #&mess($do);
         $r=&exe("$do");
         #&mess("$do<hr>$r");
          if ($r ne '') {  print $r; sleep(2); }

   }
   sleep(1);


  ##################################
   #set defaults for windows sharing
   #########

   print "<br>done..</b>";
   if ($in{'autoselect_crypt'}=~/on/) {
         print "<br><b>please backup key and try a lock/unlock!</b>";
         sleep(2);
   }

   sleep(1);
   $in{'autoselect_pool'}="";
   $in{'l3'}="";


   &reload;

    exit;
}





###############################################
#end of my script, do not delete the line below
1;