#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my (@p,$r,$p,@m,$m);  # declare all your variables as local or you will get errors

  # menue actions
  ###############
  # common lib
     require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/moverlib.pl";

    if ($in{'autoselect_rule'} eq "-select-") { $in{'answered'}="";  }
    if ($in{'submit_ok'} ne "submit")         { $in{'answered'} =""; }

    if ($in{'answered'}) {     # question was answered
       &my_test;               # do it
    }

    # ask
       $t="/var/web-gui/_log/datamover";
       @t=();
       &read_dir("$t","t",'.cfg');           # -> @t
       @m=sort @t;
       $p[0]="-select-";

       foreach my $m (@m) {
                if (!($m=~/\.cfg$/)) { next; }                #no rule

                #not for method cmd
                $r=&my_read($m);
                $t="mover_$m"."_autoselect_method";
                if ( ($r) && ("cpio|move|filesync"=~/$p{$t}/) ) {  push (@p,"$m"); }      #mover_test2.cfg_autoselect_method
       }

       #&print_array(@p);

       my $s=join(",",@p);
       print "<b>Results of find for a cpio or move method</b><br><br>";
       print "If you request a longrunning method, check logs in menu 'show log'<br>A cmd method must be tested separately<br><br> ";

       &ask('begin');
       &ask('autoselect_rule','Select a cpio or move method',$s,$in{'autoselect_rule'});
       &ask('select_opt','Test or execute a cpio/move','testrun,execute');
       &ask('end');

       if ($in{'autoselect_rule'} ne "-select-") {
            if (-f "/var/web-gui/_log/datamover/$in{'autoselect_rule'}") {
               print "<br><br><b>Datamover $in{'autoselect_rule'}</b><pre>";
               $r=`cat /var/web-gui/_log/datamover/$in{'autoselect_rule'}`;

               @t=split(/\n/,$r);
               foreach my $t (@t) {
                 $p=index($t,"\t");
                 $p=30-$p;
                 $p=" " x $p;
                 $t=~s/\t/$p\t/;

               }
               $r=join("\n",@t);
               print "$r</pre>";
            }
       }

       # header
       print "<script language='javascript'>document.getElementById('hl').innerHTML='Mover testrun'</script>\n";
       &log_end;

       } #/ my_action



##############
sub my_test {
##############
  my ($r,$do,$t,@t,$tm,$pathmethod,$sourcepath);

  # do not start this job twice
     $t=`ps axw | grep datamover.pl | grep _$in{'autoselect_rule'} | grep -v grep | grep -v sudo`;
     if ($t=~/datamover/s) {
          @t=split(/\n/,$t);
          if (@t>1) {
            print "Datamover $in{'autoselect_rule'} is running: <br>Try later or check results in menu 'show log'\n\n";
            exit;
          }
     }

  $r=&my_read($in{'autoselect_rule'}); # read config

  #debug
  #&print_hash(%p);

  $t="mover_$in{'autoselect_rule'}"."_select_abspath";   # abs | rel
  $pathmethod=$p{$t};                                    # mover_test.cfg_select_abspath

  $t="mover_$in{'autoselect_rule'}"."_select_src_zfs";   # source zfs
  $sourcepath=$p{$t};                                    # mover_test.cfg_select_src_zfs

  $t="mover_$in{'autoselect_rule'}"."_value_src_folder";# source folder
  $sourcepath.=$p{$t};                                    # mover_test.cfg_value_src_folder

  #&print_hash(%sys);

  #test or execute?
  $do="test_$in{'autoselect_rule'} $sys{'date_all'}";
  if ($in{'select_opt'} eq  "execute") {  $do="run_$in{'autoselect_rule'} $sys{'date_all'}"; }

  if (-f "/var/web-gui/_log/datamover/$in{'autoselect_rule'}.ok") {
    `sudo rm /var/web-gui/_log/datamover/$in{'autoselect_rule'}.ok`;
  }

  # start always background, wait for result?
  print "<b>Datamover testrun: $in{'autoselect_rule'} in $in{'select_mode'} mode</b><br>\n";

  # create script
  if (-f "/tmp/datamover.sh") {
          &exe("rm /tmp/datamover.sh");
  }
  open (PF, ">/tmp/datamover.sh");          # list
        flock(PF, LOCK_EX);
        print PF "/usr/bin/perl /var/web-gui/data/napp-it/zfsos/_lib/illumos/agents/datamover.pl $do\n";
  close (PF);

  print "<br><tt>Start mover in background mode, wait or check menu 'show log' for results<br>\n";

  $t=$do; $t=~s/ .*//; $t.=" debug";
  print "CLI command for debugging: perl /var/web-gui/data/napp-it/zfsos/_lib/illumos/agents/datamover.pl $t<br>\n";

  `sudo /usr/bin/at -s -f "/tmp/datamover.sh" now`;
  &exe("rm /tmp/datamover.sh");

  print "<br>wait max 60s for result of $do  ...</tt><br><pre>";
  $tm=time();
  while (1) {
    $t=time();
    if ($t-$tm>60) { print "find/action runs too long, check logfiles $in{'autoselect_rule'}.$sys{'date_all'}.* later in menu 'show log'"; exit; }

    if (-f "/var/web-gui/_log/datamover/$in{'autoselect_rule'}.$sys{'date_all'}.oklog")   {
      if (-f "/var/web-gui/_log/datamover/$in{'autoselect_rule'}.$sys{'date_all'}.findlog")  {
         $r=`cat /var/web-gui/_log/datamover/$in{'autoselect_rule'}.$sys{'date_all'}.findlog`;
         if (!($r=~/\w/s)) { $r="-nothing found with this settings-"; }
         print "\n<b>$in{'autoselect_rule'}.$sys{'date_all'}.findlog</b>\n$r";
      }
      if (-f "/var/web-gui/_log/datamover/$in{'autoselect_rule'}.$sys{'date_all'}.errlog")   {
         $r=`cat /var/web-gui/_log/datamover/$in{'autoselect_rule'}.$sys{'date_all'}.errlog`;

         $r=~s/\n/\n\n/s;  # newline after command
         $r=~s/\|/|\n/;    # line too long
         print "\n\n<b>$in{'autoselect_rule'}.$sys{'date_all'}.errlog</b>\n$r";
      }
      print "\n\n<b>$in{'autoselect_rule'}.$sys{'date_all'}.oklog</b>\n" . `cat /var/web-gui/_log/datamover/$in{'autoselect_rule'}.$sys{'date_all'}.oklog`."";

      print "</pre>"; &log_end; exit;
    }

    sleep(1);
  }

  print "</pre>";
  &log_end;
  exit;

}


###############################################
#end of my script, do not delete the line below
1;