sub my_action {
###############

  # may 2016
  # problem with SSL_v3
  # requires modification of tls.pl (disable usage of v3)
  # see https://rt.cpan.org/Public/Bug/Display.html?id=77401

  # july 2016, add fqdn
  # jan, 23 2023, modify tls and my_fqdn

  my ($out, $var, $host,$smtp,$host,$to,$server,$from,@to,$r);

  # header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='TLS (use without support)'</script>\n";

  #defaults
  $host=&exe('hostname');                      # hostname only
  # $host=&my_fqdn;          &mess($host);
  # $t='$host'; &mess($t);

  $from=$cfg{'value_smtp-to'};
  $from=~s/,.*//;
  $from=~s/.*\@/\@/;                           # domain-name of first email to have a valid from domain
  $from="napp-it_noreply_$host"."$from";       # ex napp-it_noreply_backup21@myorg.com
  if ($cfg{'value_smtp-from'}=~/\@/) { $from=$cfg{'value_smtp-from'}; }
  $from=~s/\s//g;


  if ($in{'answered'}) {
    &send_smtp($in{'value_smtp'},$from,$in{'value_smtp-to'},'This is a napp-it testmail','hello world',$in{'value_smtp-user'},$in{'value_smtp-pw'});        #server,from,to,sub,text
  }

  $server=$cfg{'value_smtp'};                # from napp-it setup
  $to=$cfg{'value_smtp-to'};                 # from napp-it setup
  @to=split(/,/,$to);

  print "smtp-test:<br>info: if you cannot connect your mailserver or pw was wrong, you will get the error: Can't call method \"mail\" on an undefined value\n <br>If you get a 'No SASL mechanism found' error, your mailserver is not supported, try another one and set a forwarder<hr>";

  #create form with defaults from napp-it setup
  print "\n<br><br>\smtp-test</b><br><br>\n";
  &ask('begin');

  &ask('value_smtp','ip or hostname of your smtp server ex smtp.gmail.com:',$cfg{'value_smtp'});
  &ask('value_smtp-user','smtp username',$cfg{'value_smtp-user'});
  &ask('value_smtp-pw','smtp-pw:',$cfg{'value_smtp-pw'});
  &ask('value_smtp-to','mailto (single mailadress only):',$cfg{'value_smtp-to'});


  &ask('end');
  print "send testmail";

  print "<br><br><hr>Smtp mail delivery via TLS over port 587 is needed for example with Gmail. <br>In order to use TLS, you need to manually install the needed perl TLS modules<br><br>";

} #/ my_action


############### server,from,to,sub,text
sub send_smtp   {
###############
  my ($t,@to);
  my $server=$_[0];
  my $from=$_[1];
  my $to=$_[2];                #opt commalist a@xx.com,b@xx.com,c@xx.com
  my $sub=$_[3];
  my $text=$_[4];
  my $user=$_[5];
  my $pw=$_[6];

  my $host=&my_fqdn;

  #&mess("server,from,to,sub,text <br>$server, $from, $to, $sub, $text");

  #if (!($cfg{'value_smtp'}=~/\w+/))    { &mess('please set a smtp-server in napp-it - setup'); }
  #if (!($cfg{'value_smtp-to'}=~/\@/))  { &mess('please set a mailto in napp-it - setup'); }


 # test for sending mail vie module Net::SMTP see http://perldoc.perl.org/Net/SMTP.html
 # port 465 or 587


  print "<pre>";

  use Net::SMTP;
  use Authen::SASL qw(Perl);

  my $smtp = Net::SMTP->new("$server",
  SSL => 1,
  #Port => 587,
  Debug => 1,
  Hello => "$host",
  Timeout => "30",) || &mess("could not connect $host to smtp-server $server");

  $smtp->auth("$user","$pw");

  ####

  $smtp->mail($from);

  $smtp->to($to);
  $smtp->data();
  $smtp->datasend("From: $from\n");
  $smtp->datasend("To: $to\n");

  $smtp->datasend("Subject: Test Email\n");
  $smtp->datasend("\n");
  $smtp->datasend("This is a test email sent over TLS with the STARTTLS extension.\n");
  $smtp->dataend();
  $smtp->quit;

  print "\nmessage was send .. $smtp\n\n</pre>";

  &log_end;
  exit;

}

###########
sub my_fqdn {
###########
   my (@v,$v,$t,$h,@f,$f);
   $h=`hostname`;
   chomp($h);

   #hostname like host.domain.org
   if ($h=~/\w+\.\w+\.\w+/) { return($h); }

   # else add .local
   $h=$h.'.local';
   return ($h);

}

###############################################
#end of my script, do not delete the line below
1;
