#!"\xampp\perl\bin\perl.exe"

## shebang needed only for tests !! calling only via perl auto.pl not via cgi !!
## auto.pl  parameter opt jobid -> run now

## (c) Gnther Alka  2010-2024
# feb 2024, win

# this script is called from jobservervice (admin) every minute
# it will then read all jobs in /_log/jobs
# and execute sub auto_job from file job.pl , if job is planned now

#define global var and settings
use strict;
use vars qw(@post $tpath $dpath $wpath @j $id $p @w $wpath $par $os $auto_os $path $logpath $log $date_all $ydat $date_us $date_and_time $isdst $sec $min $hour $mday $mon $year $wday $dow $date $t $f @t %t @m %m $r %zfs %sys %cfg %current %disk %txt);

$par=$ARGV[0];
if (!(defined($par))) { $par=""; }

@post=();

####### presets

use lib "/xampp/web-gui/data/cs_server/CGI";
$wpath="/xampp/web-gui";
$dpath="/xampp/web-gui/data";
$tpath="/xampp/web-gui/tmp";

use Fcntl qw(:flock);                                                               # filelocking
$|=1;                                                                               # keine Pufferung, no buffering

use LWP::UserAgent;                         #for grouplib post
use HTTP::Request::Common qw(POST);

$log="$wpath/_log/auto.log";
`echo '' > $log`;

      $f="windows";

       $t="$wpath/data/wwwroot/cgi-bin/admin-wlib.pl";
       require "$t";
       &getdate;

        #require jobs.lib
                $t=$0;
                $t="$wpath/data/menues/_lib/$f/jobslib.pl";                    # require zfs-lib
                require "$t";                                                                       #require jobs-lib


        #require zfs_lib
                $t="$wpath/data/menues/_lib/$f/zfslib.pl";                                # require zfs-lib
                require "$t";

        #require group_lib
                $t="$wpath/data/menues/_lib/$f/grouplib.pl";                                # require zfs-lib
                require "$t";


#months
        @m=();
        @m=('','jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec');

# as a service
while (1) {
     &getp;
     &getmydate;
     $t=60-$sec;

     print "\n###############\nauto service: $date_and_time\n";
     print "wait $t sec until next full minute\n";
     sleep($t);

     if (-f "$wpath/cfg/autojobs.disabled") {
       print "autoservice disabled\n";
       next;
     }

     #lets go
     &look_for_jobs;
     sleep(5);
}
exit;


###############
sub my_jobpar {
###############
   # par str
   my $data=$_[0];
   %current=();
   my ($v,@v);
   my @data=split(/\n/,$data);
   foreach my $l (@data) {
           @v=();
           @v=split(/=/,$l);
           if (($v[0] ne "") && ($v[1] ne "")) {
               $current{$v[0]}=$v[1];
           }
   }
}



###################
sub look_for_jobs {
###################
  my ($r,$logf,@w,$id,$t,$tmp,$err,$last,$job,@plus,$m,$h,$d,$mo,$time,$no);

  #read all jobs
  #get path to logfolder  napp-it/_log/jobs/
  $logf="$wpath/_log/jobs/";

  @m=();
  &read_dir($logf,'m','\.par$');

  if (@m==0) { print "\nno job\n"; }
  foreach $job (@m) {

         #no job
         if (!($job=~/\.par$/)) { next; }

         &getmydate;

         $id=$job;
         $id=~s/\..*//;

         # jobpar
         ########
         #print "type $logf$job\n";
         $t=`powershell -command type $logf$job`;
         &my_jobpar($t);

         #status
         #######
         if ($current{'status'} ne 'active') {
              #&autolog("job $id status: $current{'status'}");
              next;
         }
         print "process job $job\n";

         #check repli
         #if (($current{'job'}=~/repli/) && (!($cfg{'ver'}=~/c|r/))) {
         #    &autolog(" job $job replicate not auto-executed: - valid replication extension required");
         #    next;
         #}

         #check report
         #if (($current{'job'}=~/report/) && (!($cfg{'ver'}=~/\w/))) {
         #    &autolog(" job $job replicate not auto-executed: - napp-it Pro required");
         #    next;
         #}

          #this month: every or 3 or 4;7  (4 and 7) or every-n
                $mo=$mon; $mo=~s/^0+//; if ($mo eq "") { $mo="0"; }
                if (! (($current{'month'}=~/\b$mo\b/) || ($current{'month'} =~/every/)) )   { next; }

          ##month every-(2,3,4,6)
                if (($current{'month'}=~/every\-2/) && (!(",2,4,6,8,10,12,"=~/,$mo\,/)) )   { next;  }
                if (($current{'month'}=~/every\-3/) && (!(",3,6,9,12,"=~/,$mo\,/)) )        { next;  }
                if (($current{'month'}=~/every\-4/) && (!(",4,8,12,"=~/,$mo\,/)) )          { next;  }
                if (($current{'month'}=~/every\-6/) && (!(",6,12,"=~/,$mo\,/)) )            { next;  }


         # monthy every/n1;n2 -> every not n1 or n2
                $no=0;
                if ($current{'month'}=~/every\/\d/) {
                   $t=$current{'month'};
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($mon==$w)  {
                        &autolog("job $id\: skip month $w auto $current{'job'}");
                        $no=1;        # not in this month
                     }
                   }
                }
                if ($no)   { next; }  # skip

         #this day: mon, every
                $dow=&getmydow;
                if ($current{'day'} =~/^\w\w\w$/) {                                          # mon, tue,..
                        if (!($current{'day'} eq "$dow"))  { next; }
                }

         # day 3 or 4-7 (4 plus 7)
                if ($current{'day'}=~/\d/) {
                        $d=$mday; $d=~s/^0+//; if ($d eq "") { $d="0"; }
                        if (! (($current{'day'}=~/\b$d\b/) || ($current{'day'} =~/every/)) ) { next; }
                }

         ##day every-(2,3,7,14)
                if (($current{'day'}=~/every\-2/)  && (!(",2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,"=~/,$d\,/)) )   { next;  }
                if (($current{'day'}=~/every\-3/)  && (!(",3,6,9,12,15,18,21,24,27,30,"=~/,$d\,/)) )    { next;  }
                if (($current{'day'}=~/every\-7/)  && (!(",7,14,21,28,"=~/,$d\,/)) )                    { next;  }
                if (($current{'day'}=~/every\-14/) && (!(",14,28,"=~/,$d\,/)) )                         { next;  }

         # day every/n1;n2 -> every not n1 or n2
                $no=0;
                if ($current{'day'}=~/every\/\d/) {
                   $t=$current{'day'};
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($mday==$w)  {
                        &autolog("job $id\: skip day $w auto $current{'job'}");
                        $no=1;        # not in this day
                     }
                   }
                }
                if ($no)   { next; }  # skip

         # mon-fri, mon-sat, sat-sun, first-sun, first-sat
               if (($current{'day'} eq "mon-fri") && (!("mon,tue,wed,thu,fri"=~/$dow/)) )                { next;  }
               if (($current{'day'} eq "mon-sat") && (!("mon,tue,wed,thu,fri,sat"=~/$dow/)) )            { next;  }
               if (($current{'day'} eq "sat-sun") && (!("sat,sun"=~/$dow/)) )                            { next;  }
               if ($current{'day'} eq "first-sun") {
                     if ($dow ne "sun")        { next;  }
                     if ($mday > 7)            { next;  }        #7
               }
               if ($current{'day'} eq "first-sat") {
                     if ($dow ne "sat")        { next;  }
                     if ($mday > 7)            { next;  }
               }

         #this hour: every or 3 or 4-7 (4 plus 7)
                $h=$hour; $h=~s/^0+//; if ($h eq "") { $h="0"; }
                if (! (($current{'hour'}=~/\b$h\b/) || ($current{'hour'} =~/every/)) ) { next; }

         #hour every-(2,3,4,6,12)  opt (ABCD) in min and hour see after min
                if (($current{'hour'}=~/every\-2/) && (!(",0,2,4,6,8,10,12,14,16,18,20,22,"=~/,$h\,/)) )   { next;  }
                if (($current{'hour'}=~/every\-3/) && (!(",0,3,6,9,12,15,18,21,"=~/,$h\,/)) )              { next;  }
                if (($current{'hour'}=~/every\-4/) && (!(",0,4,8,12,16,20,"=~/,$h\,/)) )                   { next;  }
                if (($current{'hour'}=~/every\-6/) && (!(",0,6,12,18,"=~/,$h\,/)) )                        { next;  }
                if (($current{'hour'}=~/every\-12/) && (!(",0,12,"=~/,$h\,/)) )                            { next;  }

         # hour every/n1;n2 -> every not n1 or n2
                $no=0;
                if ($current{'hour'}=~/every\/\d/) {
                   $t=$current{'hour'};
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($hour==$w)  {
                       &autolog("job $id\: skip hour $w auto $current{'job'}");
                       $no=1;        # not in this hour
                     }
                   }
                }
                if ($no)   { next; }  # skip

         # ABCD in hour
                my $ok="";
                if ($current{'hour'}=~/A/) {
                  if (",0,1,2,3,4,5,"=~/,$h\,/)          { $ok.="1";  }  else { $ok.="0"; }
                }
                if ($current{'hour'}=~/B/)  {
                  if (",6,7,8,9,10,11,"=~/,$h\,/)        { $ok.="1";  }  else { $ok.="0"; }
                }
                if ($current{'hour'}=~/C/)  {
                  if (",12,13,14,15,16,17,"=~/,$h\,/)    { $ok.="1";  }  else { $ok.="0"; }
                }
                if ($current{'hour'}=~/D/)  {
                  if (",18,19,20,21,22,23,"=~/,$h\,/)    { $ok.="1";  }  else { $ok.="0"; }
                }

                if ($ok ne "") {
                    if (!($ok=~/1/)) { next; }
                }
                ################

                ## once or every n  minutes
                if ($current{'min'} eq "once") {
                     if (-f "$wpath/tmp/$id.once") {  next; }
                     `echo "$wpath/tmp/$id.once`;
                } else {
                    #this min: every or 15 or 15-30 (15 plus 30)
                    $m=$min; $m=~s/^0+//; if ($m eq "") { $m="0"; }
                    if (! (($current{'min'}=~/\b$m\b/) || ($current{'min'} =~/every/)) ) { next; }
                }

                ##min every-(2,3,5,10,15,30)
                if (($current{'min'}=~/every\-2\b/) && (!(",0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40,42,44,46,48,50,52,54,56,58,"=~/,$m\,/)) )   {  next;  }
                if (($current{'min'}=~/every\-3\b/) && (!(",0,3,6,9,12,15,18,21,24,27,30,33,36,39,42,45,48,51,54,57,"=~/,$m\,/)) )   { next;  }
                if (($current{'min'}=~/every\-5/) && (!(",0,5,10,15,20,25,30,35,40,45,50,55,"=~/,$m\,/)) )   { next;  }
                if (($current{'min'}=~/every\-10/) && (!(",0,10,20,30,40,50,"=~/,$m\,/)) )   { next;  }
                if (($current{'min'}=~/every\-15/) && (!(",0,15,30,45,"=~/,$m\,/)) )         { next;  }
                if (($current{'min'}=~/every\-20/) && (!(",0,20,40,"=~/,$m\,/)) )            { next;  }
                if (($current{'min'}=~/every\-30/) && (!(",0,30,"=~/,$m\,/)) )               { next;  }


                ####
                # min every/n1;n2 every not n1 or n2
                $no=0;
                if ($current{'min'}=~/every\/\d/) {
                   $t=$current{'min'};
#print "cmin: $t in min $min\n";
                   $t=~s/every\///;  # n1 or n1;n2;..
                   @w=();
                   @w=split(/;/,$t);
                   foreach my $w (@w) {
                     if ($min==$w)  {
#print "skip: $w\n";
                         &autolog("job $id\: skip min $w auto $current{'job'}");
                         $no=1;        # not in this min
                     }
                   }
                }
                if ($no)   { next; }  # skip

#if ($id=~/106/) {
#&autolog("job $id\: xxxx start auto $current{'job'}");
#}
#print "start auto $current{'job'} $id\n";

           my $time=time();
           &autolog("job $id\: start auto $current{'job'}");
           ## request job
           &my_taskexec("job-$current{'job'}","$id");


                 #REM 'start napp-it background server service'
                 #powershell -command "start-process C:\xampp\perl\bin\perl.exe script.pl -WindowStyle minimized"

                 # Unix
                 #        $t=$current{'job'};
                 #        .request -> perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/taskexec.pl
                 #        open (PF, ">/tmp/nappit/job-$t\_$id.request");          # ex ex /tmp/nappit/job-scrub_1350378156.request
                 #              flock(PF, LOCK_EX);
                 #              print PF "run_$id $time";
                 #        close (PF);

                 if (-f "$wpath/tmp/job-$t\_$id.cancel")  { `del $wpath/tmp/job-$t\_$id.cancel`; }     # del last cancel req

   }
   return;
   #/ look for jobs

}


###############
sub no_restart {
#####
       ## do not start multiple times with same par

       #todo: create tmp/job.pid and check against
       return;

       my $time=time();

       my $r=`ps axw | grep web-gui`;
       my @t=split(/\n/,$r);
       my $f="1";
       foreach my $t (@t)  {
               if ($t=~/grep/)   { next; }
               if ($t=~/server/) { next; }
               if (($t=~/$_[0]/) && ($t=~/$_[1]/)) {
                    if ($f eq "1") { $f++; next; }

                    #debug
                    # print "########## taskexec.pl $par already started\n";
                    exit;
               }
       }
       #debug
       # print "taskexec 103 $time run $_[0] $_[1]\n";

       return;   # continue
       #####


}

################
sub my_taskexec {
#################
       my $par=$_[0];            # job-scrub
       my $id=$_[1];             # jobid

       #debug
       #print "start taskexec.pl 29 $par\n";

       # par= a/tmp/nappit/bc.request
       &log("taskexec.pl 374: parameter $par $id","ta");

       #  parameter  already in %current
       #&read_ahfile("$par","t","a","taskexec.pl 36");

      #script
      my $n=1;
      $t="$wpath/data/menues/_lib/windows/scripts/$par\.pl";
      if (-f "$t") { $n="0"; }

      if ($n) {
        &log("taskexec.pl 96: error, no jobfile");
        print "393 no jobscript: $t\n";
        return;
      }


      # exec, max 2 parameter, todo
      &no_restart($f,$t[0]);

      &log("taskexec.pl 69: execute $f @t","t");


      #REM 'start napp-it background server service'
      $t=~s/\//\\/g;
      print "powershell start-process -WorkingDirectory $wpath -filepath C:\\xampp\\perl\\bin\\perl.exe -argumentlist \"$t\",\"run_$id\" -WindowStyle minimized\n";
      `powershell start-process  -WorkingDirectory $wpath -filepath C:\\xampp\\perl\\bin\\perl.exe -argumentlist \"$t\",\"run_$id\" -WindowStyle minimized`;       # minimized=debugmode, jobs run locally


          #$r=`uname -a`;
          #if ($r=~/^Linux/i) {
          #  `perl /var/web-gui/data/scripts/$f $t[0] $t[1] >/dev/null 2>&1`;             # avoids shell spamming in Linux when deleted
          #} else {
          #  exec("perl","/var/web-gui/data/scripts/$f","\'$t[0]\'","\'$t[1]\'");
          #}
         #
}
#########
sub autolog {
########
  my (@data,$log,$t,$info);
  my $info=$_[0];        # log text

  $log="$wpath/_log/auto.log";                                      # $path = path to ../napp-it/_log/


  #log newest at top
  ###################
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$date_all\: $info\n");

  if (@data > 100) {
             $t=@data-100;
             splice(@data,100,$t);
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);
 return;
}



sub getmydate {                # setzt datumsvariablen
###########
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 $date_and_time = "$mday\.$mon\.$year, $hour:$min $sec s";
 $date = "$mday\.$mon\.$year";
 $date_us= "$mon\.$mday\.$year";
 $date_all="$year\.$mon\.$mday\.$hour\.$min\.$sec";
}

############# dow of today
sub getmydow {
#day of week (tt.mm.jjjj)
 my $day="$mday.$mon.$year";

 my @day = ("sun","mon","tue","wed","thu","fri","sat");
 my @d = (0,3,2,5,0,3,5,1,4,6,2,4);
 my @tmp;
 @tmp=split(/\./,$day);
 my $t=$tmp[0];
 my $m=$tmp[1];
 my $j=$tmp[2];
 if ($j < 100) { $j =2000+$j; }
 if ($m < 3) { $j-- ; }
 $tmp[3] = $day[($j+int($j/4)-int($j/100)+int($j/400)+$d[$m-1]+$t) % 7];
 return ($tmp[3]);
}

###############################################
#end of my script, do not delete the line below